<template>
    <template v-if="!isLoading">
        <form @submit.prevent="onSubmit" class="space-y-4">
            <div class="form-control">
                <label class="flex flex-col" for="name">
                    <div>
                        Tên bài kiểm tra <span class="text-red-500">*</span>
                    </div>
                    <input
                        v-model="data.name"
                        id="name"
                        type="text"
                        class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                        :class="{ 'border-red-400': dataErrors.name }"
                    />
                </label>
                <div
                    v-if="dataErrors.name"
                    class="text-left text-sm text-red-500 mt-1"
                >
                    {{ dataErrors.name }}
                </div>
            </div>

            <div class="form-control">
                <label class="flex flex-col" for="lesson_id">
                    <div>
                        Thêm cho bài học <span class="text-red-500">*</span>
                    </div>
                    <select
                        v-model="data.lesson_id"
                        id="lesson_id"
                        class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2.5"
                        :class="{ 'border-red-400': dataErrors.lesson_id }"
                    >
                        <option disabled value=""
                            >Chọn bài học muốn thêm</option
                        >
                        <option
                            :key="lesson.id"
                            v-for="lesson in lessons"
                            :value="lesson.id"
                        >
                            {{ lesson.name }}
                        </option>
                    </select>
                </label>
                <div
                    v-if="dataErrors.lesson_id"
                    class="text-left text-sm text-red-500 mt-1"
                >
                    {{ dataErrors.lesson_id }}
                </div>
            </div>

            <div class="form-control">
                <label class="flex flex-col" for="list_question_id">
                    <div>
                        Danh sách câu hỏi <span class="text-red-500">*</span>
                    </div>
                    <Select2
                        v-model:value="data.list_question_id"
                        :options="listQuiz"
                        isMultiple
                        isNotCloseOnSelect
                    />
                </label>
                <div
                    v-if="dataErrors.list_question_id"
                    class="text-left text-sm text-red-500 mt-1"
                >
                    {{ dataErrors.list_question_id }}
                </div>
            </div>

            <div class="form-control">
                <label class="flex flex-col" for="order">
                    <div>
                        Thời gian làm bài (phút)
                        <span class="text-red-500">*</span>
                    </div>
                    <input
                        v-model.number="data.time_work"
                        id="time_work"
                        type="number"
                        class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                        :class="{ 'border-red-400': dataErrors.time_work }"
                        placeholder="Số nguyên..."
                    />
                </label>
            </div>

            <div class="form-control">
                <label class="flex flex-col" for="min_mark_achieved">
                    <div>Số điểm tối thiểu để qua bài test</div>
                    <input
                        v-model.number="data.min_mark_achieved"
                        id="min_mark_achieved"
                        type="number"
                        class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                        :class="{
                            'border-red-400': dataErrors.min_mark_achieved
                        }"
                        placeholder="Số nguyên..."
                    />
                </label>
            </div>

            <div class="form-control">
                <label class="flex flex-col" for="description">
                    <div class="mb-1">Mô tả</div>
                    <QuillEditor
                        id="description"
                        v-model:content="data.description"
                    />
                </label>
            </div>

            <div class="form-control flex items-center gap-3">
                <BasicButton type="submit">
                    {{ isUpdate ? "Cập nhật" : "Tạo" }}
                </BasicButton>
                <BasicButton
                    @click="$router.go(-1)"
                    classCustom="bg-color-danger hover:shadow-hover-danger"
                >
                    <span>Hủy</span>
                </BasicButton>
            </div>
        </form>
    </template>
    <template v-else>
        <div class="text-center">
            <SpinLoading />
        </div>
    </template>
</template>

<script>
import { reactive, ref } from "vue";
import { useRouter } from "vue-router";
import { createToast } from "mosha-vue-toastify";

import useFetchAllQuiz from "@/hooks/quiz/useFetchAllQuiz";
import useCreateTest from "@/hooks/test/useCreateTest";
import useUpdateTest from "@/hooks/test/useUpdateTest";

import SpinLoading from "@/components/loading/SpinLoading.vue";
import BasicButton from "@/components/button/BasicButton.vue";
import QuillEditor from "@/components/quill-editor/QuillEditorVue3.vue";
import Select2 from "@/components/select/Select2.vue";

export default {
    components: {
        SpinLoading,
        BasicButton,
        QuillEditor,
        Select2
    },
    props: {
        courseId: {
            type: Number,
            required: true
        },
        courseCategoryId: {
            type: Number,
            required: true
        },
        lessons: {
            type: Array,
            required: true
        },
        test: {
            type: Object
        }
    },
    setup(props) {
        const router = useRouter();
        const isUpdate = ref(props.test ? true : false);
        const { errorResponse, onCreateTest } = useCreateTest();
        const { errorResponseUpdate, onUpdateTest } = useUpdateTest();
        const { isLoading, listQuiz, onFetchAllQuiz } = useFetchAllQuiz();

        const data = reactive({
            name: props.test ? props.test.name : "",
            lesson_id: props.test ? props.test.lesson_id : "",
            list_question_id:
                props.test && props.test.list_question_id
                    ? JSON.parse(props.test.list_question_id)
                    : "",
            time_work: props.test ? props.test.time_work : "",
            min_mark_achieved:
                props.test && props.test.min_mark_achieved
                    ? props.test.min_mark_achieved
                    : "",
            description:
                props.test && props.test.description
                    ? props.test.description
                    : ""
        });

        const dataErrors = reactive({
            name: null,
            lesson_id: null,
            list_question_id: null,
            time_work: null
        });

        async function onFetchListQuiz() {
            await onFetchAllQuiz(props.courseCategoryId);
            listQuiz.value = listQuiz.value.map(quiz => {
                return {
                    id: quiz.id,
                    text: quiz.name.replace(/<p>|<\/p>/g, "")
                };
            });
        }
        onFetchListQuiz();

        async function onSubmit() {
            dataErrors.name = null;
            dataErrors.lesson_id = null;
            dataErrors.list_question_id = null;
            dataErrors.time_work = null;

            let input_valid = true;
            // check empty input
            if (
                !data.name ||
                data.lesson_id === "" ||
                !data.list_question_id ||
                !data.time_work
            ) {
                input_valid = false;
                if (!data.name)
                    dataErrors.name = "Bạn chưa nhập tên bài kiểm tra";
                if (data.lesson_id === "")
                    dataErrors.lesson_id = "Bạn chưa chọn bài học";
                if (!data.list_question_id)
                    dataErrors.list_question_id = "Bạn chưa chọn câu hỏi";
                if (!data.time_work)
                    dataErrors.time_work = "Bạn chưa nhập thời gian làm bài";
            }

            // check input valid and submit form
            if (input_valid) {
                // ép kiểu string cho danh sách câu hỏi
                let listQuizSelected = data.list_question_id.map(item =>
                    parseInt(item)
                );
                data.list_question_id = JSON.stringify(listQuizSelected);

                // show loading
                document.getElementById("full-page-loading").style.display =
                    "block";

                if (isUpdate.value) {
                    await onUpdateTest(props.test.id, data);
                } else {
                    await onCreateTest(data);
                }

                // hide loading
                document.getElementById("full-page-loading").style.display =
                    "none";

                // check error from server
                if (errorResponse.value || errorResponseUpdate.value) {
                    if (errorResponseUpdate.value) {
                        errorResponse.value = errorResponseUpdate.value;
                    }
                    if (
                        errorResponse.value.name &&
                        errorResponse.value.name.length
                    ) {
                        dataErrors.name = errorResponse.value.name[0];
                    }
                    if (
                        errorResponse.value.lesson_id &&
                        errorResponse.value.lesson_id.length
                    ) {
                        dataErrors.lesson_id = errorResponse.value.lesson_id[0];
                    }
                    if (
                        errorResponse.value.list_question_id &&
                        errorResponse.value.list_question_id.length
                    ) {
                        dataErrors.list_question_id =
                            errorResponse.value.list_question_id[0];
                    }
                    if (
                        errorResponse.value.time_work &&
                        errorResponse.value.time_work.length
                    ) {
                        dataErrors.time_work = errorResponse.value.time_work[0];
                    }
                } else {
                    createToast(
                        isUpdate.value
                            ? "Cập nhật bài kiểm tra thành công"
                            : "Thêm bài kiểm tra thành công",
                        {
                            showIcon: true,
                            type: "success"
                        }
                    );
                    router.push({
                        name: "teacher-course-view",
                        params: { courseId: props.courseId },
                        hash: "#lessons"
                    });
                }
            }
        }

        return {
            isUpdate,
            data,
            dataErrors,
            isLoading,
            listQuiz,
            onSubmit
        };
    }
};
</script>
